F - Prime Path
题目:
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
代码如下:
//#include<bits/stdc++.h>
#include<iostream>
#include<cstdio>
#include<cstring>
#include<queue>
using namespace std;
int prime[10010];
int t[5];//用于保存一个四位数的四个位数的值
int vis[10010];//用于判重;
struct Node
{
int x;//改变一位之后新产生的数字
int step;//保存步数
};
void find_prime()//打表寻找素数
{
memset(prime,0,sizeof(prime));
prime[1] = 1;//1是素数
for(int i = 2;i < 10010;i++)
{
if(prime[i] == 0)
{
for(int j = 2;i * j < 10010;j++) prime[i * j] = 1;
}
}
}
int bfs(int a,int b)
{
int temp,num;//分别用于储存中间值和计算后的值
memset(vis,0,sizeof(vis));//开始时全是新点
queue<Node> q;
Node node1,node2;
node1.step = 0;
node1.x = a;
vis[node1.x] = 1;//标记为旧点
q.push(node1);
while(!q.empty())
{
node1 = q.front();
q.pop();
if(node1.x == b) return node1.step;
t[4] = node1.x % 10;//保存四位数的个位
t[3] = (node1.x / 10) % 10;//保存十位
t[2] = (node1.x / 100) % 10;//保存百位
t[1] = (node1.x / 1000) % 10;//保存千位
for(int i = 1;i <= 4;i++)
{
temp = t[i];//用于保存
for(int j = 0;j < 10;j++)
{
if(t[i] != j)
{
t[i] = j;
num = t[1] * 1000 + t[2] * 100 + t[3] * 10 + t[4];
}
if(prime[num] == 0 && num >= 1000 && num <= 9999 && vis[num] == 0)
{
node2.step = node1.step + 1;
node2.x = num;
q.push(node2);
vis[num] = 1;
}
}
t[i] = temp;//还原
}
}
return -1;//此时证明没找到满足的点
}
int main()
{
int T,a,b,ans;
find_prime();
scanf("%d",&T);
while(T--)
{
scanf("%d%d",&a,&b);
ans = bfs(a,b);
if(ans != -1) cout << ans << endl;
else cout << "Impossible" << endl;
}
return 0;
}
打表 + BFS,打表用于找出所有的素数,通过每次改写数字中的某一位来BFS。